Skip to main content Skip to footer

Inserting a Custom SVG Icon into ComboBox in Angular

Background:

In some Angular applications, developers may want to customize the appearance of a ComboBox by displaying an SVG icon in front of the selected value in the input field, not just in the dropdown list. While Wijmo's ComboBox does not natively support input icons, this behavior can be achieved using native DOM access in combination with Angular lifecycle hooks.

Steps to Complete:

  1. Add an #inputGroup template reference to locate the ComboBox input
  2. Use ngAfterViewInit to insert the icon after the view is initialized
  3. Update the icon in response to value changes using the selectedIndexChanged event
  4. Add styling to position the icon properly

Getting Started:

Add template reference to the ComboBox container

In your Angular component’s template, add a wrapper around the ComboBox and give it a template reference:

<div class="wj-input-group" #inputGroup>
  <wj-combo-box
    [itemsSource]="items"
    displayMemberPath="name"
    (selectedIndexChanged)="onSelectionChange()"
    style="width: 250px;">
  </wj-combo-box>
</div>

 

Insert the icon using native DOM in ngAfterViewInit

In the component class, use @ViewChild to access the container and insert the icon after the view is initialized:

import { AfterViewInit, Component, ElementRef, ViewChild } from '@angular/core';

@Component({
  selector: 'app-combo-icon',
  templateUrl: './combo-icon.component.html',
  styleUrls: ['./combo-icon.component.css']
})
export class ComboIconComponent implements AfterViewInit {
  @ViewChild('inputGroup', { static: false }) inputGroupRef!: ElementRef;
  icon1: string = '<svg width="16" height="16" ...>...</svg>'; // your SVG markup
  items = [{ name: 'Option 1' }, { name: 'Option 2' }];

  ngAfterViewInit(): void {
    this.insertIcon();
  }

  onSelectionChange(): void {
    if (!this.inputGroupRef.nativeElement.querySelector('.input-icon')) {
      this.insertIcon();
    }
  }

  private insertIcon(): void {
    const inputGroup = this.inputGroupRef.nativeElement;
    const iconSpan = document.createElement('span');
    iconSpan.className = 'input-icon';
    iconSpan.innerHTML = this.icon1;
    inputGroup.insertBefore(iconSpan, inputGroup.firstChild);
  }
}

 

Style the icon with CSS

In your component's CSS file, add styles to position the icon inside the input group:

.wj-input-group {
  position: relative;
}

.input-icon {
  position: absolute;
  top: 50%;
  left: 8px;
  transform: translateY(-50%);
  pointer-events: none;
}

You may also want to add left padding to the ComboBox input so that the text doesn’t overlap the icon.

This solution works well in Angular and provides full control over the SVG icon's appearance and placement in the input area of a ComboBox.

Hope you found this article helpful. Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Inserting a Custom SVG Icon into ComboBox in React

Custom SVG Image in ComboBox

Background:

FlexComboBox (Wijmo ComboBox) lets you customize how items are displayed in the drop-down list. One powerful way to enhance usability is to add custom SVG icons next to each item, useful for visual categories, status indicators, or branding. Below is a React-style approach to do exactly that.

Steps to Complete:

  1. Prepare a data source that includes an icon identifier or SVG source per item.
  2. Use a custom itemFormatter (or itemTemplate) to render the SVG icon alongside the item text.
  3. Optionally apply CSS to adjust spacing and alignment.

Getting Started:

Prepare a data source that includes an icon identifier or SVG source per item

Each ComboBox item will contain both a label and an SVG path/identifier. We include an icon property in each data object.

const items = [
  {
    name: 'Home',
    icon: '<svg width="16" height="16" …><!-- SVG markup for home --></svg>'
  },
  {
    name: 'Work',
    icon: '<svg width="16" height="16" …><!-- SVG markup for work --></svg>'
  },
  {
    name: 'Settings',
    icon: '<svg width="16" height="16" …><!-- SVG markup for settings --></svg>'
  }
];
  • Each object has a name and an icon field.
  • The icon field contains inline SVG strings that can be rendered directly in React.
  • This structure lets the ComboBox know what text and icon should appear per item.

 

Use a custom itemFormatter (or itemTemplate) to render the SVG icon alongside the item text

The itemFormatter (or wjItemTemplate) let you fully control how each item is drawn. We’ll prefix the item label with the SVG icon markup.

import { ComboBox } from '@mescius/wijmo.react.input';

export default function App() {
  const itemFormatter = (item, index, formatted) => {
    // Insert custom SVG plus name text
    return (
      <div className="combo-item">
        <span
          className="combo-icon"
          dangerouslySetInnerHTML={{ __html: item.icon }}
        />
        <span className="combo-text">{item.name}</span>
      </div>
    );
  };

  return (
    <ComboBox
      itemsSource={items}
      displayMemberPath="name"
      itemFormatter={itemFormatter}
    />
  );
}
  • itemFormatter is a React prop that you define as a function.
  • It receives each item and returns a custom JSX structure.
  • We inject the SVG via dangerouslySetInnerHTML because it contains raw SVG.

 

Optionally apply CSS to adjust spacing and alignment

CSS ensures the icon and text are aligned nicely in the dropdown list.

.combo-item {
  display: flex;
  align-items: center;
}

.combo-icon {
  display: inline-block;
  margin-right: 8px;
  width: 16px;
  height: 16px;
}

.combo-text {
  flex: 1;
}
  • .combo-item aligns icon and text horizontally.
  • .combo-icon adds spacing so text doesn’t sit too close to the icon.

 

With this React setup:

  • Each ComboBox entry displays an SVG icon alongside its label.
  • The icons render inline, so there’s no flicker, no external resource loading.
  • Users get a richer visual experience that’s especially helpful in menus or selection lists.

Happy coding!

Andrew Peterson

Technical Engagement Engineer